/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 1994,2012          */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
#ifndef _H_PM_UTIL
#define _H_PM_UTIL
/* "@(#) 1.8.2.17 src/ppe/poe/include/pm_util.h, ppe.poe, ppe_rbarlx2, rbarlx2s006a 12/06/09 11:34:42\0" */
/****************************************************************************

 Name: pm_util.h

 Description: Function prototypes and macro definitions for C code
		using the Parallel Utility Subroutines.

 Product Classification:

 Licensed Materials - Property of IBM

 5765-D93 (C) Copyright IBM Corporation, 1994, 1999

 All rights reserved.
 US Government Users Restricted Rights - Use, Duplication or Disclosure
 restricted by GSA ADP Schedule Contract with IBM Corp.

 #private
 Author: 
 Owner:

 Notes: Much of this file is extracted from pm_poe.h which is used internally
	by several PM routines and contains material not suitable for delivery
	to our customer's.  The long range mechanism for avoiding a problem 
 	of dual maintainance could be for pm_poe.h to include this header in
        place of the defines it now provides explicitly . (May not need to be
	done though because the number of defines here is small and the values    
	are unlikely to change.)

 History:
   Date     Who Mod ID  Description
   ----     --- ------  -----------
   04/05/94 RRT         file created 
   10/19/95 GJM		added functions for rcv-n-call performance improvements
			(defect 13420)
   11/30/95 GJM		added mpc_isatty (feature 15185)
   12/11/97 Adn         Add support for Checkpoint/Restart (F5055)
   12/03/99 WGT         Add pm_child_sig_handler for users (D59524)
    1/14/00 PFC         Removed author from prolog. (D60277)
   10/26/04 PFC         added mpc_bandwidth (F113439)
   06/20/05 PFC         added include of stdio.h (D123487)
   03/02/06 PFC         added include of sys/types.h (D133976)
 #eprivate
***************************************************************************/

/****************************************************************************
   Included files (for signal and file definitions)
***************************************************************************/
#include <sys/signal.h>
#include <stdio.h>
/* add types header for bandwidth stats struct */
#include <sys/types.h>

/****************************************************************************
   Symbolic names
***************************************************************************/
/* symbolic names for stdio */
#define STDIN 0
#define STDOUT 1
#define STDERR 2

/* miscellaneous symbolic constants */
#define SPMD 1   /* Single program, multiple data mode */
#define MPMD 0   /* Multiple program, multiple data mode */

/* symbolic constants and data type for bandwidth stats */
/* #define MP_BW_LAPI 1 Supported removed for PE Runtime */
#define MP_BW_MPI  2

typedef struct {
	unsigned long long switch_sent;
	unsigned long long switch_recv;
	int64_t time_sec;
	int32_t time_usec;
} bw_stat_t;


/****************************************************************
   enumeration of mp_euilibnum library selection
   defined by mp_euilib string
****************************************************************/

#define LIB_ANY   0    /* undefined library */
#define LIB_IP    1    /* ip library */
#define LIB_US    3    /* user space library */

/****************************************************************
   enumeration of mpc_stdoutmode selection
****************************************************************/

#define STDIO_ORDERED 	-2
#define STDIO_UNORDERED -3
#define STDIO_COMBINED  -4

#define STDIO_MULTI	STDIO_ORDERED
#define STDIO_ASYNC 	STDIO_UNORDERED

/***************************************************************
  Function Prototypes for Parallel Utility Routines
****************************************************************/
 
#ifdef __cplusplus
extern "C"
{
#endif

    int mpc_flush(int option);
    int mpc_stdout_mode(int mode);
    int mpc_stdoutmode_query(int *mode);
    int mpc_disableintr(void);
    int mpc_enableintr(void);
    int mpc_queryintr(void);
    int mpc_queryintrdelay(void);
    int mpc_setintrdelay(int val);
    int mpc_isatty(int fd);
    int mp_chkpt(int flag);
    void pm_child_sig_handler(int, siginfo_t *, void *, pthread_t);
    int mpc_statistics_write(FILE* fptr);
    int mpc_statistics_zero (void);
    int mpc_bandwidth (uint handl, int flag, bw_stat_t *in1);

    /* for Wtime */
    int _mp_Wtime_init();
    int _mp_Wtime_rollback_init();
    double _mp_Wtime();
    double _mp_Wtick();
    int _mp_Wtime_term();
    int _mp_Wtime_stop();
    int _mp_Wtime_restart();

    int _mp_clocks_synched(int local_val);
#ifdef __cplusplus
}
#endif

#endif  /* _H_PM_UTIL */
