/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 1999,2012          */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
#ifndef POEAPI_H
#define POEAPI_H

#include <stdint.h>

typedef struct POE_TASKINFO {
    char  *h_name;      /* host name          */
    char  *ip_addr;     /* IP address         */
    int    task_id;     /* task ID            */
    int    session_id;  /* session ID         */
    pid_t  pid;         /* child process ID   */
    char  *p_name;      /* child process name */
} POE_TASKINFO;

int poe_master_tasks(pid_t **poe_master_pids);       
    /* RC = -3 : invalid poe_master_pids argument. */
    /*    = -2 : unable to allocate memory.        */
    /*    = -1 : a system error occurred.          */
    /*    =  0 : no POE master process running.    */
    /*    >  0 : size of array that (*poe_master_pids) points to. */

int poe_task_info(pid_t poe_master_pid, POE_TASKINFO ***poe_taskinfo);
    /* RC = -3 : invalid poe_taskinfo argument. */
    /*    = -2 : unable to allocate memory.     */
    /*    = -1 : a system error occurred.       */
    /*    =  0 : poe_master_pid is invalid or task information not yet available. */
    /*    >  0 : size of NULL terminated array that (*poe_taskinfo) points to.    */

typedef enum {
    NOTIFICATION_TASKID
}poe_failure_type_t;

typedef struct{
    poe_failure_type_t  type;       /* content type of this union */
    union {
        uint32_t            task_id;    /* ID of the failed task */
    }failure_data;
} poe_failure_t;

typedef int (*poe_exit_callback)(poe_failure_t);
int poe_register_exit_callback(poe_exit_callback cb);

#endif  /* POEAPI_H */
