/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 2006,2012          */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/*
 *   File name: nrt_api.c
 *
 *   History:
 *   10/29/08 JHE M01 Linux port (D153816)
 *
 *
 *   Origins:
 *                   Copyright IBM Corporation 2006
 *
 *                         All Rights Reserved
 *
 *   Permission to use, copy, modify, and distribute this software and its
 *   documentation for any purpose and without fee is hereby granted,
 *   provided that the above copyright notice appear in all copies and that
 *   both that copyright notice and this permission notice appear in
 *   supporting documentation, and that the name of IBM not be
 *   used in advertising or publicity pertaining to distribution of the
 *   software without specific, written prior permission.
 *
*/

#pragma comment(copyright,"5765-PEA (C) Copyright IBM Corp. 2006,2008")
#pragma comment(user,"@(#) 1.3 src/ppe/poe/samples/nrt/nrt_api.c, ppe.poe.samples, ppe_rfal, rfal0701a 07/01/09 10:54:27")
#include <stdio.h>
#include <unistd.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>
#include <netdb.h>
#include <sys/types.h>
#include <nrt.h>
#include <stdint.h>
#include <sys/param.h>

#define RSCT_DEVTYPE_INFINIBAND 	0


char device[8];
int i=0;
int rc=0;
pid_t pid;
uid_t uid;
int 		adapter_type=0;
uint16_t	context_id=0;
uint32_t	num_tasks=0;
uint32_t  	job_key=0;
uint16_t  	win_id=0;
uint32_t  	node_number=0;
uint8_t		port_id=0;
uint32_t	base_lid=0;
uint32_t	task_id=0;
uint64_t        network_id=0;
char 		job_name[8]="aaa";  
char 		protocol_name[8]="xxx";
char 		node[MAXHOSTNAMELEN];
int nrt_api_status();
int nrt_api_load();
int nrt_api_unload();
int print_rc(int);

int main(int argc, char **argv)
{
    int ch;
    extern int optind;
    extern char *optarg;

    /*******************************************************/
    /* Process the command line options.                   */
    /*******************************************************/
    while ((ch = getopt(argc, argv, "luhs")) != EOF) {
        switch(ch) {
            case 'l':  /* Load Partition. */
                        nrt_api_load();
                        exit(0);

            case 'u':  /* Unload Partition. */
                        nrt_api_unload();
                        exit(0);

            case 's':  /* show status. */
                        if (argv[optind] == NULL) {
                                fprintf(stderr, "No device name was specified for -s flag \n");
                                exit(1);
                        }
                        strcpy(device, argv[optind]);
                        nrt_api_status();
                        exit(0);

            case 'h':  /* help - usage */
            default :
                        fprintf(stderr, "Usage: nrt_api [-l] [-u] [-s device] [-h]\n");
                        fprintf(stderr, "       -l          - load the network resource table on this node.\n");
                        fprintf(stderr, "       -u          - unload the network table windows on this node.\n");
                        fprintf(stderr, "       -s device   - display the network table windows on this node.\n");
                        fprintf(stderr, "       -h          - usage message.\n");
                        exit(1);
        }
    }
	return 0;
}

int nrt_api_status()
{

    	fprintf(stdout,"NRT version is %d\n", NRT_VERSION);
    	fprintf(stdout,"User ID is %d\n", getuid());
        nrt_cmd_query_adapter_names_t   adapter_name;
        nrt_cmd_query_adapter_info_t    adapter_info_table;
	int j,k;
	nrt_cmd_query_adapter_types_t   adapter_types;

        adapter_types.num_adapter_types = (unsigned int*) malloc(sizeof(unsigned int));
        adapter_types.adapter_types = (nrt_adapter_t *)malloc(sizeof(nrt_adapter_t) * 6);
        adapter_name.max_windows = (unsigned int *)malloc(sizeof(unsigned int));
        adapter_name.num_adapter_names = (unsigned int *)malloc(sizeof(unsigned int));
        rc = nrt_command(NRT_VERSION, NRT_CMD_QUERY_ADAPTER_TYPES, &adapter_types);
        if (rc) {
                fprintf(stderr, "Bad rc %d from NRT_CMD_QUERY_ADAPTER_TYPES\n", rc);
                print_rc(rc);
                exit(rc);
        }
        fprintf(stdout, "adapter types number: %d\n", *adapter_types.num_adapter_types);
        for(i=0; i<*adapter_types.num_adapter_types; i++)
        {
                switch(adapter_types.adapter_types[i]){
                        case 0: fprintf(stdout,"adapter types %d: NRT_IB\n",i);break;
                        case 1: fprintf(stdout,"adapter types %d: NRT_HFI\n",i);break;
                        case 2: fprintf(stdout,"adapter types %d: NRT_IPONLY\n",i);break;
                        case 3: fprintf(stdout,"adapter types %d: NRT_HPCE\n",i);break;
                        case 4: fprintf(stdout,"adapter types %d: NRT_KMUX\n",i);break;
                        case 5: fprintf(stdout,"adapter types %d: NRT_MAX_ADAPTER_TYPES\n",i);break;
                        default: fprintf(stdout,"UNKOWN ADAPTER TYPES\n");
                }
        }

        for(i=0; i<*adapter_types.num_adapter_types; i++)
        {
                adapter_name.adapter_type = adapter_types.adapter_types[i];
                rc = nrt_command(NRT_VERSION, NRT_CMD_QUERY_ADAPTER_NAMES, &adapter_name);
                if(rc) {
                        fprintf(stderr, "Bad rc %d from NRT_CMD_QUERY_ADAPTER_NAMES\n", rc);
                        print_rc(rc);
                        exit(rc);
                }

                printf("\n-------------------------------------------------------------------\n");
                fprintf(stdout, "adapter type %d max windows: %d ,names number %d\n",
			 i,*adapter_name.max_windows,*adapter_name.num_adapter_names);
                for(j=0; j< *adapter_name.num_adapter_names; j++)
                {
                        fprintf(stdout, "adapter type %d adapter name: %s\n", i, adapter_name.adapter_names[j]);
                        adapter_info_table.adapter_type = adapter_name.adapter_type;
                        adapter_info_table.adapter_name = adapter_name.adapter_names[j];
                        adapter_info_table.adapter_info = (nrt_adapter_info_t *)malloc(sizeof(nrt_adapter_info_t));
                        adapter_info_table.adapter_info->window_list = (nrt_window_id_t *)malloc(sizeof(nrt_window_id_t)*512);
                        rc = nrt_command(NRT_VERSION, NRT_CMD_QUERY_ADAPTER_INFO, &adapter_info_table);
                        if(rc)
                        {
                                fprintf(stderr, "Bad rc %d from NRT_CMD_QUERY_ADAPTER_INFO\n", rc);
                                print_rc(rc);
                        }
                        fprintf(stdout, "adapter type %d nrt node number: %u ,number port: %d\n", 
				i, adapter_info_table.adapter_info->node_number,adapter_info_table.adapter_info->num_ports);
                        for(k=0; k<adapter_info_table.adapter_info->num_ports; k++)
                        {
                                fprintf(stdout, "adapter type %d port id: %d, ", i, 
					adapter_info_table.adapter_info->port[k].port_id);
                                fprintf(stdout, "status: %d, ", adapter_info_table.adapter_info->port[k].status);
                                fprintf(stdout, "logical id: %d, ", adapter_info_table.adapter_info->port[k].lid);
                                fprintf(stdout, "network id: %lu, ", adapter_info_table.adapter_info->port[k].network_id);
                                fprintf(stdout, "specail: %lu, ", adapter_info_table.adapter_info->port[k].special);
                                fprintf(stdout, "if_name: %s, ", adapter_info_table.adapter_info->port[k].if_name);
                                fprintf(stdout, "if_status: %d\n", adapter_info_table.adapter_info->port[k].if_status);
                        }
                        free( adapter_info_table.adapter_info->window_list);
                printf("\n-------------------------------------------------------------------\n");
                }

        }


	fprintf(stdout,"Getting status for device %s\n",device);
        nrt_cmd_status_adapter_t     adapter_status;
        adapter_status.adapter_name = device;
        adapter_status.adapter_type = adapter_type;
        adapter_status.window_count = (nrt_window_id_t *)malloc(sizeof(nrt_window_id_t));
        adapter_status.status_array = (nrt_status_t **)malloc(sizeof(nrt_status_t*)*256);
        for(i=0; i<256; i++)
        {
                adapter_status.status_array[i] = (nrt_status_t *)malloc(sizeof(nrt_status_t)*256);
        }
        rc = nrt_command(NRT_VERSION, NRT_CMD_STATUS_ADAPTER, &adapter_status);
        if(rc) {
                fprintf(stderr, "Bad rc %d from NRT_CMD_STATUS_ADAPTER.\n", rc);
                print_rc(rc);
                exit(rc);
        }
        fprintf(stdout,"Number of windows reporting status: %d\n",*adapter_status.window_count);
        for(i=0; i<*adapter_status.window_count; i++)
        {
                fprintf(stdout,"window ID %d, user uid: %d, pid: %d, ",
		        (*adapter_status.status_array)[i].window_id,
			(*adapter_status.status_array)[i].uid,
			(*adapter_status.status_array)[i].client_pid);

		fprintf(stdout,"bulk transfer: %d, rcontext blocks:%d, state: ",
			(*adapter_status.status_array)[i].bulk_transfer,
			(*adapter_status.status_array)[i].rcontext_blocks);

                switch((*adapter_status.status_array)[i].state){
                        case 0: fprintf(stdout,"NRT_WIN_UNAVAILABLE\n"); break;
                        case 1: fprintf(stdout,"NRT_WIN_INVALID\n"); break;
                        case 2: fprintf(stdout,"NRT_WIN_AVAILABLE\n"); break;
                        case 3: fprintf(stdout,"NRT_WIN_RESERVED\n"); break;
                        case 4: fprintf(stdout,"NRT_WIN_READY\n"); break;
                        case 5: fprintf(stdout,"NRT_WIN_RUNNING\n"); break;
                        default: fprintf(stdout,"UNKOWN_STATE\n");
                }
        }

        for(i=0; i<256; i++)
        {
                free(adapter_status.status_array[i]);
        }
        free(adapter_status.status_array);
        free(adapter_status.window_count);
	exit(0);
}

	
int nrt_api_load()
{
	FILE *PT_file_p;

    /********************************************************/
    /* Get the adapter resources for IB devices             */
    /********************************************************/
	
   	fprintf(stdout,"NRT version is %d\n", NRT_VERSION);
	fprintf(stdout,"Loading network resource table using ./nrt_data file.\n");
	PT_file_p = fopen("./nrt_data", "r");

    /* check if file not found */
    if (PT_file_p == NULL) {
            fprintf(stderr, "nrt_data file not found. \n");
            exit(1);
    }

    /* get our real uid */
    uid = getuid();
    pid = getpid();

    /*
     * The 2 integers on the first line of the file represent the
     * number of tasks and the job key to use when loading the table.
     * Following that, on the same line, is a string containing the
     * adapter device name.
     */
    fscanf(PT_file_p, "%d %d %s %llu", &num_tasks, &job_key, device, &network_id);
    printf("%d %d %s %llu\n", num_tasks, job_key, device, network_id);


        nrt_cmd_load_table_t       load_table;

	load_table.table_info = (nrt_table_info_t *)malloc(sizeof(nrt_table_info_t));

        load_table.table_info->num_tasks = num_tasks;
        load_table.table_info->job_key = job_key;
        load_table.table_info->uid = uid;
        load_table.table_info->network_id = network_id;
        load_table.table_info->pid = pid;
        load_table.table_info->adapter_type = 0;   /* ib adapter_type is 0 */
        load_table.table_info->is_user_space = 1;
        load_table.table_info->is_ipv4 = 1;
        load_table.table_info->context_id = 0;
        load_table.table_info->table_id = 1;
        if (job_name == NULL) {
                fprintf(stderr, "No job name was specified \n");
                exit(1);
        } 
        strcpy(load_table.table_info->job_name,job_name);
        if (protocol_name == NULL) {
                fprintf(stderr, "No protocol name was specified \n");
                exit(1);
        }
        strcpy(load_table.table_info->protocol_name,protocol_name);
        load_table.table_info->use_bulk_transfer = 0;
        load_table.table_info->bulk_transfer_resources = 0;

    
	nrt_ib_task_info_t *per_task_input_p = (nrt_ib_task_info_t *)malloc(sizeof(nrt_ib_task_info_t)*num_tasks);
	load_table.per_task_input = per_task_input_p;
	

	for (i=0; i<num_tasks; i++) {
	
 	       	fscanf(PT_file_p, "%u %hu %d %hhu\n", &node_number, &win_id, &base_lid, &port_id);
                printf("%u %hu %d %hhu\n", node_number, win_id, base_lid, port_id);

		per_task_input_p[i].task_id = i;
		per_task_input_p[i].win_id = win_id;
		per_task_input_p[i].node_number = node_number;
		strcpy(per_task_input_p[i].device_name, device);
		per_task_input_p[i].base_lid = base_lid;
		per_task_input_p[i].port_id = port_id;
		per_task_input_p[i].lmc = 2;
		per_task_input_p[i].port_status = 1; 
	}

        rc = nrt_command(NRT_VERSION, NRT_CMD_LOAD_TABLE, &load_table);
        if(rc) {
                fprintf(stderr, "Bad rc %d from NRT_CMD_LOAD_TABLE \n",rc);
		print_rc(rc);
		exit(rc);
                }
	fprintf(stdout, "nrt Load table successfully \n");
        free(per_task_input_p);
        free(load_table.table_info);
	exit(rc);

}


int nrt_api_unload()
{
	int i, rc;
	FILE *PT_file_p;
	nrt_cmd_unload_window_t         unload_window;
	char this_node[MAXHOSTNAMELEN];
        struct hostent *he;

	fprintf(stdout,"Unloading network table windows using ./nrt_data file\n");
	PT_file_p = fopen("./nrt_data", "r");
	/* check if file not found */
	if (PT_file_p == NULL) {
		fprintf(stderr, "nrt_data file not found. \n");
		exit(1);
	}

	/* get our real uid */
	uid = getuid();

	/* get our node name */
	gethostname(this_node, MAXHOSTNAMELEN);
	/*
	 * The 2 integers on the first line of the file represent the
	 * number of tasks and the job key to use when loading the table.
	 * Following that, on the same line, is a string containing the
	 * adapter device name.
	 */
	fscanf(PT_file_p, "%d %d %s %lu", &num_tasks, &job_key, device, &network_id);

	for (i=0; i<num_tasks; i++) {
		/* lid isn't used for unload, but is there */
		fscanf(PT_file_p, "%s %hd %d", node, &win_id, &base_lid);
		/*
		 * Figure out if the window is on this node.
		 */
		unload_window.adapter_name = device;
		unload_window.adapter_type = 0;
		unload_window.job_key = job_key;
		unload_window.window_id = win_id;


		he = gethostbyname(node);
		/* M01: hostname doesnot include domain name on linux */
		if (!strncmp(he->h_name, this_node, strlen(this_node))) {
			rc = nrt_command(NRT_VERSION, NRT_CMD_UNLOAD_WINDOW, &unload_window);
			if(rc) {
				fprintf(stderr, "Bad rc %d from NRT_CMD_UNLOAD_WINDOW.\n", rc);
				print_rc(rc);
				exit(rc);
			}
			fprintf(stdout, "Unloading window %d for task %d...successfully\n", win_id, i);
		}
		else
		{
			fprintf(stdout, "hostname is incorrect.\n");
		}
	}
	return 0;
}

int print_rc(int rc)
{
	switch(rc) {
		case NRT_SUCCESS: fprintf(stdout,"NRT_SUCCESS.\n");break;
		case NRT_EINVAL: fprintf(stdout,"NRT_EINVAL - Invalid argument.\n"); break;
		case NRT_EPERM: fprintf(stdout,"NRT_EPERM - Caller not authorized.\n"); break;
		case NRT_PNSDAPI: fprintf(stdout,"NRT_PNSDAPI - PNSD API returned an error.\n"); break;
		case NRT_EADAPTER: fprintf(stdout,"NRT_EADAPTER - Invalid adapter.\n"); break;
		case NRT_ESYSTEM: fprintf(stdout,"NRT_ESYSTEM - System Error occurred.\n"); break;
		case NRT_EMEM: fprintf(stdout,"NRT_EMEM - Memory error\n"); break;
		case NRT_EIO: fprintf(stdout,"NRT_EIO - Adapter reports down.\n"); break;
		case NRT_NO_RDMA_AVAIL: fprintf(stdout,"NRT_NO_RDMA_AVAIL - No RDMA windows available.\n"); break;
		case NRT_EADAPTYPE: fprintf(stdout,"NRT_EADAPTYPE - Invalid adapter type.\n"); break;
		case NRT_BAD_VERSION: fprintf(stdout,"NRT_BAD_VERSION - Version is not correct.\n"); break;
		case NRT_EAGAIN: fprintf(stdout,"NRT_EAGAIN - Try the call again later.\n"); break;
		case NRT_WRONG_WINDOW_STATE: 
			fprintf(stdout,"NRT_WRONG_WINDOW_STATE - Window in wrong state for this operation.\n"); break;
		case NRT_UNKNOWN_ADAPTER:
			fprintf(stdout,"NRT_UNKNOWN_ADAPTER - One(or more) adapters in NRT unknown.\n"); break;
		case NRT_NO_FREE_WINDOW:
			fprintf(stdout,"NRT_NO_FREE_WINDOW - For reserve any windows(none free).\n"); break;
		case NRT_ALREADY_LOADED:
			fprintf(stdout,"NRT_ALREADY_LOADED - Nrt with same key and task config already loaded for this device.\n");
			break;
		case NRT_RDMA_CLEAN_FAILED: 
			fprintf(stdout,"NRT_RDMA_CLEAN_FAILED - task's rdma cleanup failed.\n"); break;
		case NRT_WIN_CLOSE_FAILED: fprintf(stdout,"NRT_WIN_CLOSE_FAILED - task can't close window.\n");break;
		case NRT_WIN_OPEN_FAILED: fprintf(stdout,"NRT_WIN_OPEN_FAILED - task can't open window.\n");break;
		case NRT_TIMEOUT: fprintf(stdout,"NRT_TIMEOUT - No response back from PNSD/job.\n");break;
		case NRT_WRONG_PREEMPT_STATE: fprintf(stdout,"NRT_WRONG_PREEMPT_STATE - Invalid preemption state.\n");break;
		case NRT_NTBL_LOAD_FAILED: fprintf(stdout,"NRT_NTBL_LOAD_FAILED - fail to load ntbl.\n");break;
		case NRT_NTBL_UNLOAD_FAILED: fprintf(stdout,"NRT_NTBL_UNLOAD_FAILED - fail to unload ntbl.\n");break;
		case NRT_ERR_COMMAND_TYPE: fprintf(stdout,"NRT_ERR_COMMAND_TYPE - invalid command type.\n");break;
		default: fprintf(stdout,"unknown return code %d.\n", rc);
	}
	return 0;
}
