/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* Restricted Materials of IBM                                            */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 2009,2012          */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
/* @(#)30   1.2   src/ppe/poe/include/pm_secmod.h, ppe.poe.pm, ppe_rbarlx2, rbarlx21216b 6/10/09 15:11:33 */

#include <stdlib.h>
#include <sys/uio.h>

#ifndef _H_PSM_H
#define _H_PSM_H

#ifdef __cplusplus
extern "C" {
#endif

typedef struct iovec psm_idbuf_desc, *psm_idbuf_t;

#define PSM__SUCCESS 0
#define PSM__MEMORY_ERR 1

int
psm__init(				/* one time initialization of the module */
	char *);			/* options */

int
psm__get_id_token(		/* gets a client's identity token */
	char *,				/* target user identity */
	char *,				/* tartet host name */
	psm_idbuf_t);		/* address of identity buffer descriptor */

int
psm__verify_id_token(	/* verifies a client's identity token */
	char *,				/* name of user to authorize as */
	psm_idbuf_t);		/* address of identity buffer descriptor */

int
psm__get_id_from_token(	/* returns a client's identity */
	psm_idbuf_t,		/* address of identity buffer descriptor */
	char *,				/* memory for id string */
	size_t *);			/* provided/required length of the id string */

int
psm__free_id_token(		/* frees memory allocated for id token */
	psm_idbuf_t);		/* address of identity buffer descriptor */

void
psm__cleanup();			/* one time cleanup of the module */

#ifdef __cplusplus
}
#endif

#endif	// _H_PSM_H
